<?php

namespace Acms\Services\Storage\Contracts;

use Config;

abstract class Base
{
    /**
     * @var int
     */
    protected $fileMod = 438; // ( 0666 = 438 | 0644 = 420 | 0604 = 388)

    /**
     * @var int $directoryMod
     */
    protected $directoryMod = 511; // ( 0777 = 511 | 0755 = 493 | 0705 = 453)

    /**
     * Base constructor
     */
    public function __construct()
    {

    }

    /**
     * @param int $mod
     *
     * @return void
     */
    public function setFileMod($mod)
    {
        $this->fileMod = $mod;
    }

    /**
     * @param int $mod
     *
     * @return void
     */
    public function setDirectoryMod($mod)
    {
        $this->directoryMod = $mod;
    }

    /**
     * @param string $path
     *
     * @return void
     */
    public function changeMod($path)
    {
        if ( is_dir($path)  ) {
            chmod($path, intval($this->directoryMod));
        } else {
            chmod($path, intval($this->fileMod));
        }
    }

}